# CKXKER.MAK, Version 5A(189), Tue Feb 12 23:30:00 1994
#
# This is a makefile for XPR C Kermit using Amiga Aztec C V5.n.  The lint
# line is for Gimpel FlexeLint, a commercial product.
#
# Some general notes for anyone attempting a build from source.  First,
# the required files are not all in this archive.  Any file whose name
# begins with "ck[cuw]" comes from the Kermit archive at Columbia
# University, reachable most easily by anonymous FTP to
# ftp.cc.columbia.edu.  Second, I have a precompiled version of the
# Manx "functions.h" file called "functions.pre", which gets included
# by this Makefile.
#
# -wo in CFLAGS makes pointer-int conversions a warning instead of an error,
# and is needed if you use prototypes for the Kermit functions.  In
# particular, the last argument of debug() is specified as an int, but
# actual calls often put a pointer there.
# 
# The optimization is set to so, which turns on full optimization.

# The DYNAMIC #define causes C Kermit's send and
# receive buffers to be allocated at run time, and is recommended.
# If DYNAMIC is used, small model can also be used.
#

CC = cc

# For the first XPR release, turn off nearly everything

OPTS = -DAMIGA -DDYNAMIC -DCK_ANSILIBS -DCK_ANSIC -DNODIAL -DNODEBUG \
   -DNOTLOG -DNOHELP -DNOXMT -DNOSCRIPT -DNOCMDL -DNOSPL -DNOICP \
   -DNOCSETS -DNOSERVER -DNOMSEND

OTHER = -wo -so

CFLAGS = $(OPTS) $(OTHER) -hi ckcdeb.pre

LFLAGS =

#
#  All the object files needed to compile C Kermit.
#

OBJS = libstart.o libsup.o ckxmai.o \
		 ckcpro.o ckcfns.o ckcfn2.o ckcfn3.o \
		 ckxtio.o ckxfio.o ckxtim.o

#
# The corresponding sources, used mainly to run lint.
#

SRCS = ckxmai.c \
		 ckcpro.c ckcfns.c ckcfn2.c ckcfn3.c ckuusx.c \
		 ckxtio.c ckxfio.c ckxtim.c

xprkermit.library:    $(OBJS)
	ln $(LFLAGS) -o xprkermit.library $(OBJS) -lm -lc

ckcpro.o: ckcpro.w wart
	wart ckcpro.w ckcpro.c
	cc $(CFLAGS) -o ckcpro.o ckcpro.c

wart: ckwart.o
	ln -o wart ckwart.o -lc

lint: $(SRCS)
	lint $(OPTS) $(SRCS)

$(OBJS): ckcdeb.pre

#
# Special rules for the Amiga-specific files
#

libsup.o:	libsup.c version.h
	cc $(OPTS) $(OTHER) -hi functions.pre libsup.c

ckcdeb.pre:	ckcdeb.h
	cc $(OPTS) -ho ckcdeb.pre ckcdeb.h

#
# Create the distribution archive
#

xprkermit.lha:
	lha -x -a -m a xprkermit ckxker.doc ckxmai.c ckxfio.c ckxtio.c \
	ckxtim.c ckxker.h ckxker.mak libsup.c libstart.asm version.h \
	xprkermit.library
	
